"use strict";
var ApiModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiModule = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const sdk_nestjs_monitoring_1 = require("@multiversx/sdk-nestjs-monitoring");
const api_service_1 = require("./api.service");
const api_module_options_1 = require("./entities/api.module.options");
let ApiModule = ApiModule_1 = class ApiModule {
    static forRoot(options) {
        const providers = [
            {
                provide: api_module_options_1.ApiModuleOptions,
                useFactory: () => options,
            },
            api_service_1.ApiService,
        ];
        return {
            module: ApiModule_1,
            imports: [
                sdk_nestjs_monitoring_1.MetricsModule,
            ],
            providers,
            exports: [
                api_service_1.ApiService,
            ],
        };
    }
    static forRootAsync(options) {
        const providers = [
            {
                provide: api_module_options_1.ApiModuleOptions,
                useFactory: options.useFactory,
                inject: options.inject,
            },
            api_service_1.ApiService,
        ];
        const references = [];
        if (options.imports) {
            for (const ref of options.imports) {
                references.push(ref);
            }
        }
        return {
            module: ApiModule_1,
            imports: [
                sdk_nestjs_monitoring_1.MetricsModule, ...references,
            ],
            providers,
            exports: [
                api_service_1.ApiService,
            ],
        };
    }
};
ApiModule = ApiModule_1 = tslib_1.__decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({})
], ApiModule);
exports.ApiModule = ApiModule;
//# sourceMappingURL=api.module.js.map